package common;
use strict;

#------------------------------------------------------------------------------
# ̴ؿ
#				by DEX
#				EMAIL : dex@basil.freemail.ne.jp
#				HP    : http://www1.u-netsurf.ne.jp/~dex/
#
# ʸɡEUC+LF
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
# Хѿ
#------------------------------------------------------------------------------
my($Zspace) = '(?:\xA1\xA1)'; # ѥڡ

# EUC-JPʸ
my($ascii) = '[\x00-\x7F]'; # 1Х EUC-JPʸ
my($twoBytes) = '(?:[\x8E\xA1-\xFE][\xA1-\xFE])'; # 2Х EUC-JPʸ
my($threeBytes) = '(?:\x8F[\xA1-\xFE][\xA1-\xFE])'; # 3Х EUC-JPʸ
my($character) = "(?:$ascii|$twoBytes|$threeBytes)"; # EUC-JPʸ

#------------------------------------------------------------------------------
# htmlEscape()εդԤ
#------------------------------------------------------------------------------
sub htmlUnEscape
{
	my($str) = @_;
	my %unescaped = ('lt' => '<', 'gt' => '>', 'quot' => '"', 'amp' => '&', 'nbsp' => ' ');
	$str =~ s/&(lt|gt|quot|amp|nbsp);/$unescaped{$1}/gio;
	return $str;
}

#------------------------------------------------------------------------------
# htmlǥȸʤʸѴ
#------------------------------------------------------------------------------
sub htmlEscape
{
	my($str) = @_;
	my(%escaped) = ('<' => '&lt;', '>' => '&gt;', '&' => '&amp;', '"' => '&quot;', ' ' => '&nbsp;');
	$str =~ s/([<>\"& ])/$escaped{$1}/go;
	return $str;
}

#------------------------------------------------------------------------------
# ˤäñ̤Ѵ(byte, KB, GB, TB)
# 1000 -> 1,000 byte1024 -> 1 KB
# IN : $byte, $format(ǥե"%d""%.1f"Ǿʲ1ޤ)
#------------------------------------------------------------------------------
sub formatUnitSize
{
	my($byte, $format) = @_;
	$format = "%d" unless($format);
	my($out) = "";
	my(@UNIT) = ("byte", "KB", "MB", "GB", "TB");	# ñ
	my(@SIZE) = (1024, 1048576, 1073741824, 1099511627776);	# ºݤΥ
	
	my($i) = 0;
	for(@SIZE){
		if($byte < $_){
			$byte = ($byte / $SIZE[$i-1]) if($i > 0); # Ǿñ̤ơñ̥ǳ
			$byte = common::comma(sprintf($format, $byte));	# 3˥
			$out = sprintf("%s %s", $byte, $UNIT[$i]);
			last;
		}
		$i++;
	}
	$out = sprintf("%s %s", $byte, $UNIT[0]) if($out eq "");# ñ̸Ĥʤä
	
	return $out;
}

#------------------------------------------------------------------------------
# ԥɤLF
# IN : $pStr ѿؤΥե(\$strȤͿ)
#------------------------------------------------------------------------------
sub cnvlf
{
	my($pStr) = @_;
	# $pStr =~ s/\x0D\x0A|\x0D|\x0A/\n/g; # Ʊ̣ʲᤤ
	$$pStr =~ s/\x0D\x0A/\n/g;
	$$pStr =~ tr/\x0D\x0A/\n\n/;
}

#------------------------------------------------------------------------------
# å(ॢȤ)
# $lfh = my_flock() or die 'Busy!';
#
# å(ॢȤʤ)
# 1 while (not defined($lfh = my_flock()));
#
# 餫ᡢåեȥåǥ쥯ȥѰդƤ
# ./lockdir/lockfile 0755 0644
#
# ¾
# 1.å 
# 2.եɤ߹ 
# 3.ե˽񤭹 
# 4.ե򸵥ե˥͡ह 
# 5.å 
#------------------------------------------------------------------------------
sub mylock {
	my %lfh = (dir => './lockdir/', basename => 'lockfile',
	     timeout => 60, trytime => 10, @_);
	$lfh{path} = $lfh{dir} . $lfh{basename};

	for (my $i = 0; $i < $lfh{trytime}; $i++, sleep 1) {
		return \%lfh if (rename($lfh{path}, $lfh{current} = $lfh{path} . time));
	}
	opendir(LOCKDIR, $lfh{dir});
	my @filelist = readdir(LOCKDIR);
	closedir(LOCKDIR);
	foreach (@filelist) {
		if (/^$lfh{basename}(\d+)/) {
			return \%lfh if (time - $1 > $lfh{timeout} and
			rename($lfh{dir} . $_, $lfh{current} = $lfh{path} . time));
			last;
		}
	}
	undef;
}

#------------------------------------------------------------------------------
# å
# my_funlock($lfh);
#------------------------------------------------------------------------------
sub myunlock {
	rename($_[0]->{current}, $_[0]->{path});
}


#------------------------------------------------------------------------------
# ζ
#------------------------------------------------------------------------------
sub trim
{
	my($str) = @_;
	$str =~ s/^(?:\s|$Zspace)+//o; # Ƭζʸ(ѥڡ)
	$str =~ s/^($character*?)(?:\s|$Zspace)+$/$1/o; # ζʸ(ѥڡ)
	return $str;
}


#------------------------------------------------------------------------------
# ͤ3头Ȥ˥ޤǶڤ
#------------------------------------------------------------------------------
sub comma
{
	my($num) = @_;
	my($i, $j);
	if ($num =~ /^[-+]?\d\d\d\d+/g) {
		for ($i = pos($num) - 3, $j = $num =~ /^[-+]/; $i > $j; $i -= 3) {
			substr($num, $i, 0) = ',';
		}
	}
	return $num;
}

#------------------------------------------------------------------------------
#	եιʸǼ
#------------------------------------------------------------------------------
sub getFileUpdateTime
{
	my($file) = @_;
	
	my($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime((stat($file))[9]);
	return sprintf("%04d/%02d/%02d %02d:%02d:%02d", $year+1900, $mon+1, $mday, $hour, $min, $sec);
}

#------------------------------------------------------------------------------
# Cookie񤭹
# IN
#	$cookiename	:å̾
#	$phHash		:¸ͤޤϢ
#	$date		:¸(30ʤ顢30άȥ֥饦ĤȺ)
# OUT
#	:ʤԡ顼å
#
# աContent-type˼¹ԤȡǽΣ٤ᤵơʸ񤭹ޤʤ礬롣
# Τᡢδؿϥߡإå˽ϤƤ롣
#
# DummyHeader: DummyData;
# Set-Cookie: NAME=VALUE; expires=Mon, 01-Jan-2002 12:30:00 GMT;
# Content-type: text/html; charset=Shift_JIS;
#
#------------------------------------------------------------------------------
sub cookie_write {
	my($cookiename, $phHash, $date) = @_;
	my($date_gmt) = "";
	my(@wdays) = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
	my(@mons) = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	my($err) = "";

	if($date > 0){
		# GMTλ
		my($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst)
		 = gmtime(time + $date * 86400); # 24*60*60
		$date_gmt = sprintf("%s, %02d\-%s\-%04d %02d:%02d:%02d GMT",
		$wdays[$wday], $mday, $mons[$mon], $year+1900, $hour, $min, $sec);
	}
	
	my($cookievalue, $key, $value);
	foreach $key (keys(%$phHash)) {
		$value = $phHash->{$key};
		$key =~ s/\,/&comma/g;
		$key =~ s/:/&colon/g;
		$key =~ s/;/&semicolon/g;
		$value =~ s/\,/&comma/g;
		$value =~ s/:/&colon/g;
		$value =~ s/;/&semicolon/g;
		if ($cookievalue) {
			$cookievalue .= ",$key:$value";
		} else {
			$cookievalue = "$key:$value";
		}
	}
	print "DummyHeader: DummyData;\n";
	print "Set-Cookie: $cookiename=$cookievalue;";
	print " expires=$date_gmt;" if($date_gmt);	# Cookie ͭ¤ɲ
	print "\n";
	return $err;
}

#------------------------------------------------------------------------------
# Cookieκ
# IN
#	$cookiename	:å̾
#------------------------------------------------------------------------------
sub cookie_delete {
	my($cookiename) = @_;
	print "DummyHeader: DummyData;\n";
	print "Set-Cookie: $cookiename=; expires=Thursday, 01-Jan-1970 00:00:00 GMT;\n";
}

#------------------------------------------------------------------------------
# Cookieɤ߹ߡϢ֤
# IN	: å̾
# OUT	: Ϣ
#------------------------------------------------------------------------------
sub cookie_read {
	my($cookiename) = @_;
	my($key, $value, %COOK);
	my($cookies) = $ENV{'HTTP_COOKIE'};
	my(@pairs) = split(/;/,$cookies);
	my(%dummy);
	foreach my $pair (@pairs) {
		($key, $value) = split(/=/, $pair);
		$key =~ s/ //g;
		$dummy{$key} = $value;
	}
	@pairs = split(/\,/,$dummy{$cookiename});
	foreach my $pair (@pairs) {
		($key, $value) = split(/:/, $pair);
		$key =~ s/&comma/\,/g;
		$key =~ s/&colon/\:/g;
		$key =~ s/&semicolon/\;/g;
		$value =~ s/&comma/\,/g;
		$value =~ s/&colon/\:/g;
		$value =~ s/&semicolon/\;/g;
		$COOK{$key} = $value;
	}
	return %COOK;
}

#------------------------------------------------------------------------------
# ƥȥפ
#------------------------------------------------------------------------------
sub getContentType
{
	return "Content-type: text/html; charset=EUC-JP\n\n";
}

#------------------------------------------------------------------------------
#	ǥɡѿ
#------------------------------------------------------------------------------
sub decode{
	my($phForm) = @_;
	my($buffer);
	if ($ENV{'REQUEST_METHOD'} eq "POST") {
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	} else { $buffer = $ENV{'QUERY_STRING'}; }
	my(@pairs) = split(/&/,$buffer);
	foreach my $pair (@pairs) {
		my($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		#Ѵ
		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;
		#Ѵ
		$value =~ s/\,//g;
		jcode::convert(\$value,'euc');
		$phForm->{$name} = $value;
	}
}

#------------------------------------------------------------------------------
# Ź沽ʸ
#------------------------------------------------------------------------------
sub getCrypt
{
	my($passwd) = @_;
#	srand(); # perl5.004 ʹߤ rand()¹Ի˸ƤӽФƤʤ
		 # ϼưǼ¹Ԥ
	my(@salts) = ( "A".."Z", "a".."z", "0".."9", ".", "/" );
	my($salt) = $salts[int(rand(64))] . $salts[int(rand(64))];
	return crypt($passwd, $salt);
}

#------------------------------------------------------------------------------
# getCrypt()Ǽʸå
#------------------------------------------------------------------------------
sub checkCrypt
{
	my($orgpasswd, $cryptpasswd) = @_;
	return ($cryptpasswd eq crypt($orgpasswd, $cryptpasswd));
}

#------------------------------------------------------------------------------
# ϥåƤѿȤƽ񤭽Ф($VAR1={'name' => 'value'};)
# Data::Dumperɤ
#------------------------------------------------------------------------------
sub HashDumper
{
	my($ref) = @_;
	my($out) = "\$VAR1 = {\n";
	
	for(keys(%$ref)){
		$out .= "\t'" . $_ . "' => '" . $ref->{$_} . "',\n"
	}

	$out .= "}\n";
	return $out;
}

1;
